//
//  PSPWSyncModule.h
//  PSPWare
//
//  Created by Maksim Rogov on Sun Mar 06 2005.
//  Copyright (c) 2005 Nullriver, Inc. All rights reserved.
//

#import <Foundation/Foundation.h>

#import "PSPWSyncItem.h"

@interface PSPWSyncModule : NSObject {
	id					delegate;

	NSArray				*   identifiers;
	NSMutableArray		*   syncQueue;
	NSArray				*   allSyncedFiles;
	NSMutableArray		*	syncIndex;
	unsigned long long		syncQueueSize;
	unsigned long long		syncEstimateSize;
}

- (id)initWithDelegate:(id)theDelegate;

// Accessors
- (id)delegate;
- (void)setDelegate:(id)theDelegate;
- (NSString *)pspVolume;
- (unsigned long long)syncQueueSize;
- (unsigned long long)syncEstimateSize;
+ (NSArray *)selectedIdentifiersForPSP:(NSString *)pspVolume;
+ (void)setSelectedIdentifiers:(NSArray *)theSelectedIdentifiers forPSP:(NSString *)pspVolume;
- (NSString *)moduleName;
- (NSString *)moduleSaveName;

// Typically Overriden
+ (NSArray *)availableIdentifiers;
+ (NSArray *)availableSubIdentifiersForIdentifier:(NSString *)theIdentifier;
+ (NSString *)moduleName;
+ (NSString *)moduleSaveName;
- (NSString *)rootSyncFolder;
- (BOOL)shouldClearUnsyncedFiles;
- (void)cleanUp:(NSString *)path ownOnly:(BOOL)ownOnly;
- (NSArray *)itemsToSync;

// Methods
- (void)prepare:(BOOL)forReal;
- (NSArray *)fixDuplicateDestinations:(NSArray *)itemsToSync;
- (void)filterQueue;
- (unsigned long long)calculateFileSizes;
- (void)cleanUp:(NSString *)path;
- (void)sync;
- (void)finalize;

@end
